javax.persistence

## Annotation Type PrimaryKeyJoinColumn

-     @Target(value={TYPE,METHOD,FIELD})
      @Retention(value=RUNTIME)
      public @interface PrimaryKeyJoinColumn

  Specifies a primary key column that is used as a foreign key to join to another table.

  It is used to join the primary table of an entity subclass in the `JOINED` mapping strategy to the primary table of its superclass; it is used within a `SecondaryTable` annotation to join a secondary table to a primary table; and it may be used in a `OneToOne` mapping in which the primary key of the referencing entity is used as a foreign key to the referenced entity.

  If no `PrimaryKeyJoinColumn` annotation is specified for a subclass in the `JOINED` mapping strategy, the foreign key columns are assumed to have the same names as the primary key columns of the primary table of the superclass.

          Example: Customer and ValuedCustomer subclass

          @Entity
          @Table(name="CUST")
          @Inheritance(strategy=JOINED)
          @DiscriminatorValue("CUST")
          public class Customer { ... }

          @Entity
          @Table(name="VCUST")
          @DiscriminatorValue("VCUST")
          @PrimaryKeyJoinColumn(name="CUST_ID")
          public class ValuedCustomer extends Customer { ... }

  Since:
    Java Persistence 1.0
  See Also:
    `SecondaryTable`, `Inheritance`, `OneToOne`, `ForeignKey`

- - ### Optional Element Summary

    Optional Elements
    Modifier and Type | Optional Element and Description
    --- | ---
    `String` | `columnDefinition` (Optional) The SQL fragment that is used when generating the DDL for the column.
    `ForeignKey` | `foreignKey` (Optional) Used to specify or control the generation of a foreign key constraint for the primary key join column when table generation is in effect.
    `String` | `name` (Optional) The name of the primary key column of the current table.
    `String` | `referencedColumnName` (Optional) The name of the primary key column of the table being joined to.

- - ### Element Detail

    - #### name

          public abstract String name

      (Optional) The name of the primary key column of the current table.

      Defaults to the same name as the primary key column of the primary table of the superclass (`JOINED` mapping strategy); the same name as the primary key column of the primary table (`SecondaryTable` mapping); or the same name as the primary key column for the table for the referencing entity (`OneToOne` mapping).

      Default:
        ""

    - #### referencedColumnName

          public abstract String referencedColumnName

      (Optional) The name of the primary key column of the table being joined to.

      Defaults to the same name as the primary key column of the primary table of the superclass (`JOINED` mapping strategy); the same name as the primary key column of the primary table (`SecondaryTable` mapping); or the same name as the primary key column for the table for the referencing entity (`OneToOne` mapping).

      Default:
        ""

    - #### columnDefinition

          public abstract String columnDefinition

      (Optional) The SQL fragment that is used when generating the DDL for the column. This should not be specified for a `OneToOne` primary key association.

      Defaults to the generated SQL to create a column of the inferred type.

      Default:
        ""

    - #### foreignKey

          public abstract ForeignKey foreignKey

      (Optional) Used to specify or control the generation of a foreign key constraint for the primary key join column when table generation is in effect. If this element is not specified, the persistence provider's default foreign key strategy will apply.
      Since:
        Java Persistence 2.1
      Default:
        @javax.persistence.ForeignKey(javax.persistence.ConstraintMode.PROVIDER_DEFAULT)

Copyright © 1996-2013, Oracle and/or its affiliates. All Rights Reserved. Use is subject to license terms.